// Ссылка на библиотеку https://github.com/miguelbalboa/rfid

#include <SPI.h>                      //Подключение библиотеки SPI
#include <MFRC522.h>                  //Подключение библиотеки RFID
#include <Wire.h>                     // Подключаем библиотеку Wire
#include <LiquidCrystal_I2C.h>        // Подключаем библиотеку LiquidCrystal_I2C

#define SS_PIN D4                     //На D4 подключен контакт SDA
#define RST_PIN D3                    //На D3 подключен контакт RST
MFRC522 mfrc522(SS_PIN, RST_PIN);     // Создаём экземпляр класса MFRC522

byte bukva_B[8]   = {B11110,B10000,B10000,B11110,B10001,B10001,B11110,B00000,}; // Буква "Б"
byte bukva_G[8]   = {B11111,B10001,B10000,B10000,B10000,B10000,B10000,B00000,}; // Буква "Г"
byte bukva_D[8]   = {B01111,B00101,B00101,B01001,B10001,B11111,B10001,B00000,}; // Буква "Д"
byte bukva_ZH[8]  = {B10101,B10101,B10101,B11111,B10101,B10101,B10101,B00000,}; // Буква "Ж"
byte bukva_Z[8]   = {B01110,B10001,B00001,B00010,B00001,B10001,B01110,B00000,}; // Буква "З"
byte bukva_I[8]   = {B10001,B10011,B10011,B10101,B11001,B11001,B10001,B00000,}; // Буква "И"
byte bukva_IY[8]  = {B01110,B00000,B10001,B10011,B10101,B11001,B10001,B00000,}; // Буква "Й"
byte bukva_L[8]   = {B00011,B00111,B00101,B00101,B01101,B01001,B11001,B00000,}; // Буква "Л"
byte bukva_P[8]   = {B11111,B10001,B10001,B10001,B10001,B10001,B10001,B00000,}; // Буква "П"
byte bukva_Y[8]   = {B10001,B10001,B10001,B01010,B00100,B01000,B10000,B00000,}; // Буква "У"
byte bukva_F[8]   = {B00100,B11111,B10101,B10101,B11111,B00100,B00100,B00000,}; // Буква "Ф"
byte bukva_TS[8]  = {B10010,B10010,B10010,B10010,B10010,B10010,B11111,B00001,}; // Буква "Ц"
byte bukva_CH[8]  = {B10001,B10001,B10001,B01111,B00001,B00001,B00001,B00000,}; // Буква "Ч"
byte bukva_Sh[8]  = {B10101,B10101,B10101,B10101,B10101,B10101,B11111,B00000,}; // Буква "Ш"
byte bukva_Shch[8]= {B10101,B10101,B10101,B10101,B10101,B10101,B11111,B00001,}; // Буква "Щ"
byte bukva_Mz[8]  = {B10000,B10000,B10000,B11110,B10001,B10001,B11110,B00000,}; // Буква "Ь"
byte bukva_IYI[8] = {B10001,B10001,B10001,B11001,B10101,B10101,B11001,B00000,}; // Буква "Ы"
byte bukva_Yu[8]  = {B10010,B10101,B10101,B11101,B10101,B10101,B10010,B00000,}; // Буква "Ю"
byte bukva_Ya[8]  = {B01111,B10001,B10001,B01111,B00101,B01001,B10001,B00000,}; // Буква "Я"

LiquidCrystal_I2C lcd(0x3F,16,2);           // Задаем адрес и размер дисплея

int readsuccess;
byte readcard[4];
char str[32] = "";                    // Массив для хранения UID карты.
String StrUID;                        // Строковая переменная для хранения UID карты

void setup() {
  Serial.begin(115200);               //Инициализируем серийный порт на скорости 115200
  SPI.begin();                        //Инициализируем шину SPI
  mfrc522.PCD_Init();                 //Инициализируем MFRC522
  Wire.begin(4, 5);                   // Выводы интерфейса I2C ESP8266
  lcd.init();                         // Инициализация lcd дисплея
  lcd.backlight();                    // Включение подсветки дисплея
}

void loop() {
   //киррилица
 lcd.createChar(1, bukva_I);      // И
 lcd.createChar(2, bukva_L);      // Л
 lcd.createChar(3, bukva_TS);     // Ц  
 lcd.createChar(4, bukva_Ya);     // Я
 lcd.createChar(5, bukva_Z);      // З
 lcd.createChar(6, bukva_IYI);    // Ы
 
  readsuccess = getid();              //Записываем в переменну возвращённые данные из функции 
  if(readsuccess) {                   // Если данные есть, то печатаем
      lcd.setCursor(1, 0);            // Устанавливаем курсор на 1 строку ячейку 0
      lcd.print("KAPTA  ");           // Выводим слово КАРТА 
      lcd.setCursor(8, 0);            // Устанавливаем курсор на 1 строку ячейку 7
      lcd.print(StrUID);              // Выводим номер карты 
      lcd.setCursor(1, 1);            // Устанавливаем курсор на 2 строку ячейку 1
      lcd.print("K\1PP\1\2\1\3A \4\5\6K");     // Выводим текст  
  }
}

int getid() {  
  if(!mfrc522.PICC_IsNewCardPresent()) {
    return 0;
  }
  if(!mfrc522.PICC_ReadCardSerial()) {
    return 0;
  }   
  Serial.print("UID отсканированной карты: ");  
  for(int i=0;i<4;i++){
    readcard[i]=mfrc522.uid.uidByte[i]; //Прочитаем и сохраненим идентификатор UID карты
    array_to_string(readcard, 4, str);
    StrUID = str;
  }
  mfrc522.PICC_HaltA();
  return 1;
}

void array_to_string(byte array[], unsigned int len, char buffer[]) {
    for (unsigned int i = 0; i < len; i++)
    {
        byte nib1 = (array[i] >> 4) & 0x0F;
        byte nib2 = (array[i] >> 0) & 0x0F;
        buffer[i*2+0] = nib1  < 0xA ? '0' + nib1  : 'A' + nib1  - 0xA;
        buffer[i*2+1] = nib2  < 0xA ? '0' + nib2  : 'A' + nib2  - 0xA;
    }
    buffer[len*2] = '\0';
}
